;###############################################################################
;###################         Erode image                   ####################

(define vigra_discerosion_c
  (get-ffi-obj 'vigra_discerosion_c dylib-path
               (_fun (img_vector1 img_vector2  width height radius) :: [img_vector1 : _cvector]
                     [img_vector2 : _cvector]
                     [width : _int]
                     [height : _int]
                     [radius : _int]
                     -> (res :  _int))))

(define (erodeimage-band band radius)
  (let* ((width  (band-width  band))
	 (height (band-height band))
	 (band2 (make-band width height 0.0))
	 (foo   (vigra_discerosion_c (band-data band) (band-data band2) width height radius)))
    (case foo
      ((0) band2)
      ((1) (error "Error in vigraplt.morphology:erodeimage: Erosion of image failed!!")))))

(define (erodeimage image radius)
  (map (lambda (band) (erodeimage-band band radius)) image))


;###############################################################################
;###################         Dilate image                   ####################

(define vigra_discdilation_c
  (get-ffi-obj 'vigra_discdilation_c dylib-path
               (_fun (img_vector1 img_vector2  width height radius) :: [img_vector1 : _cvector]
                     [img_vector2 : _cvector]
                     [width : _int]
                     [height : _int]
                     [radius : _int]
                     -> (res :  _int))))

(define (dilateimage-band band radius)
  (let* ((width  (band-width  band))
	 (height (band-height band))
	 (band2 (make-band width height 0.0))
	 (foo   (vigra_discdilation_c (band-data band) (band-data band2) width height radius)))
    (case foo
      ((0) band2)
      ((1) (error "Error in vigraplt.morphology:dilateimage: Dilation of image failed!!")))))

(define (dilateimage image radius)
  (map (lambda (band) (dilateimage-band band radius)) image))

;###############################################################################
;###################         Opening  image                 ####################

(define (openingimage-band band radius)
  (dilateimage-band (erodeimage-band band radius) radius))

(define (openingimage image radius)
  (dilateimage (erodeimage image radius) radius))


;###############################################################################
;###################         Closing image                  ####################

(define (closingimage-band band radius)
  (erodeimage-band (dilateimage-band band radius) radius))

(define (closingimage image radius)
  (erodeimage (dilateimage image radius) radius))